%
% Generate random systems and test munorm code with complex uncertainty
%

clear
format long e

% On problems where the maximum is very flat, for instance around w=0
% (which is the default initial frequency) the algorithm sometimes
% will take a very large number of iterations (even though the optimal
% value has been reached already) unless the desired guaranteed tolerance 
% is set very large, e.g., 0.01.
% tol=0.01
tol = 1e-4;

options(1) = 0;
options(2) = 0;

getsaved = 0;
if getsaved == 1
   load tempdata A B C D;
else
   [A,B,C,D]=unpck(sysrand(6,3,3,1));  % General stable system
   % D=zeros(3);
   save tempdata A B C D;
end

blk=[1 1; 1 1; 1 1];  % three scalar complex blocks (nonrepeated)

[mu_nm,w_hat]=munorm(A,B,C,D,blk,options,tol)

disp('Invoking mutools on a grid to generate a muhat plot:')

N=50;
w=logspace(-2,1,N);
[bnds,rowd,sens,rowp,rowg] = mu(frsp(pck(A,B,C,D),w),blk,'ucU');
semilogx(w,mu_nm*ones(N))
hold on
semilogx(bnds(:,3),bnds(:,1));
hold off
max(bnds(:,1))


