%
% Generate random systems and test munorm code
%

format long e
tol=1e-4;

n=6;
[A,B,C,D]=unpck(sysrand(n,3,3,1)); % Generate stable system
D=zeros(3);
blk=[1 1; 1 1; 1 1];

%flop_cnt1=flops;
[mu_nm]=munorm(A,B,C,D,blk)
%flop_cnt1=flops-flop_cnt1

% [Az,Bz,Cz,Dz]=bilinear(-A,B,-C,D,0.5);
% [mu_nm]=munorm(Az,Bz,Cz,Dz,blk,[1 2])

% Compute alternative approximation
%
% Do bilinear transformation
%flop_cnt2=flops;
%[Az,Bz,Cz,Dz]=bilinear(A,B,C,D,0.5);
%gam_l=0;
%gam_u=2;
% Generate upper bound
%done=0;
%while done==0,
%   M=[Az Bz; (1/gam_u)*Cz (1/gam_u)*Dz];
%   blk2 = [n 0; blk];
%   [bnds,dvec,sens,pvec] = mu(M,blk2,'ucU');
%   mu_nm2=bnds(1,1);
%   if mu_nm2<1
%      done=1;
%   else
%      gam_l=gam_u;
%      gam_u=gam_u*2;
%   end
%end
% Bisection alg.
%while (gam_u - gam_l)>=tol,	
%   gam=(gam_u+gam_l)/2;
%   M=[Az Bz; (1/gam)*Cz (1/gam)*Dz];
%   [bnds,dvec,sens,pvec] = mu(M,blk2,'ucU');
%   mu_nm2=bnds(1,1);
%   if mu_nm2>=1
%      gam_l=gam;
%   else
%      gam_u=gam;
%   end
%end
%gam
%flop_cnt2=flops-flop_cnt2

N=50;
w=logspace(-2,1,N);
% w=0:.1:2*pi;
[bnds,rowd,sens,rowp,rowg] = mu(frsp(pck(A,B,C,D),w),blk,'ucU');
% [bnds,rowd,sens,rowp,rowg] = mu(frsp(pck(Az,Bz,Cz,Dz),w),blk,'ucU');
% plot(bnds(:,3),bnds(:,1))
semilogx(w,mu_nm*ones(N))
hold on
semilogx(bnds(:,3),bnds(:,1))
hold off


